Kickstart Templates Don't Render FreeIPA Snippet correctly
Status: Closed   

Priority: High   

Assignee: Stephen Benjamin   

Category: Templates   

Target version: 1.5.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.5.0

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

In order to have backward compatibility with earlier versions of Foreman, the template checks if `@host.respond_to? :otp`, but this

doesn't work in safe mode, even after adding it to the Jail.

Associated revisions

Revision 77d9d699 - 04/28/2014 02:25 PM - Stephen Benjamin

fixes #5450 - add realm to params for 1.4-compatible use in templates

Revision 03118084 - 04/28/2014 02:57 PM - Stephen Benjamin

fixes #5450 - add realm to params for 1.4-compatible use in templates

(cherry picked from commit 77d9d699b32e735e4b70195e978de108a992d3f5)

History

#1 - 04/25/2014 03:54 PM - Stephen Benjamin

https://github.com/theforeman/community-templates/blob/master/kickstart/provision_rhel.erb#L101

#2 - 04/27/2014 09:09 AM - Stephen Benjamin

@host.methods doesn't actually return all the available methods in the safe mode jail, which is why respond_to? doesn't work as expected.  Anyway,

we're stuck with identifying a Realm-capable foreman version using only the features 1.4.  This simply will cause the template not to render on < 1.5:

<% if @host.otp && @host.realm && @host.realm.realm_type == "FreeIPA" && os_major <= 6 -%>

 The only way I see is to add something to 1.5 that lets us know we can do realms, but that still works on 1.4...so, as far as I can see, that means

abusing an existing hash.

What about adding this to Host::Managed#info?

param["realm"] = realm.name if realm

 Then:

<% if @host.params["realm"] && @host.otp && @host.realm.realm_type == "FreeIPA" && os_major <= 6 -%>

#3 - 04/27/2014 09:18 AM - Stephen Benjamin

- Priority changed from Normal to High

Ah sorry, should be this, but same idea:

<% if @host.info["parameters"]["realm"] && @host.otp && @host.realm.realm_type == "FreeIPA" && os_major <= 6 -

%>

 But anyway, as it stands in the RHEL KS template, the freeipa_snippet will never be reached because of the failing respond_to?

#4 - 04/28/2014 09:34 AM - Stephen Benjamin
https://github.com/theforeman/community-templates/blob/master/kickstart/provision_rhel.erb#L101


- Status changed from New to Ready For Testing

PR's:

https://github.com/theforeman/foreman/pull/1406

https://github.com/theforeman/community-templates/pull/76

#5 - 04/28/2014 02:32 PM - Dominic Cleal

- Assignee set to Stephen Benjamin

- Target version set to 1.8.3

- translation missing: en.field_release set to 4

#6 - 04/28/2014 03:31 PM - Stephen Benjamin

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 77d9d699b32e735e4b70195e978de108a992d3f5.
